##############################################################################
# Copyright (C) 2001 Kim Nikolay <fafhrd@datacom.kz>

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

##############################################################################

"""Portal Localizer tool."""
__version__='$Revision: 0.1 $'[11:-2]

import os, sys, Globals
from Products.CMFCore.utils \
     import UniqueObject, getToolByName, SimpleItemWithProperties
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions \
     import ManagePortal, AccessContentsInformation
from Globals import InitializeClass, DTMLFile
from AccessControl import ClassSecurityInfo
from utils import _dtmldir

from Products.Localizer import Localizer, MessageCatalog


class LocalizerTool(UniqueObject, Localizer.Localizer):
    '''  '''
    id = 'portal_localizer'
    meta_type = 'Portal Localizer'

    security = ClassSecurityInfo()

    def manage_options(self):
        """ depends of Localizer class """
        o = [ { 'label' : 'Overview', 'action' : 'manage_overview'} ]
        o += Localizer.Localizer.manage_options(self)
        return o

    def __init__(self, languages=['en']):
        Localizer.Localizer.__init__(self, 'Portal Localizer', languages)
        self._v_hook = 0
        self._setObject('Messages',
                        MessageCatalog.MessageCatalog('Messages',
                                                      '', languages))

    #
    #    ZMI methods
    #
    security.declareProtected( ManagePortal, 'manage_overview')
    manage_overview = DTMLFile( 'explainLocalizerTool', _dtmldir)

    #
    #   'portal_localizer' interface methods
    #
    def __call__(self, message, messageCatalog='Messages', lang=None, add=1):
        """ """
        try:
            return self[mesageCatalog](message, lang, add)
        except:
            return message

        

InitializeClass(LocalizerTool)
